# IMPORTANT NOTE: the .tar.gz used here is not the vanilla tarball
# from apache.org since that does not unpack properly using Solaris
# tar.  This -RH.tar.gz is created by unpacking the vanilla .zip 
# file on a Solaris machine, then tar'ing that up again.

Summary: Tomcat Java Servlet Engine
Name: tomcat
Version: 4.0.5
Release: 1
Vendor: Red Hat, Inc.
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-buildroot
Source: jakarta-tomcat-%{version}-RH.tar.bz2
Source1: tomcat.init
Source2: tomcat.logrotate
Source3: tomcat.sysconfig
Source5: server.xml
Source6: locate_jdk.pl
Source7: tomcat-4.0.3-servlets.tar.gz
Source9: dos2unix.py
Patch2: tomcat-4.0.5-policy.patch
License: Apache
Prereq: /sbin/chkconfig, /sbin/service, /usr/sbin/useradd, /usr/sbin/groupadd
BuildPrereq: python
Requires: perl, IBMJava2-SDK

BuildArch: noarch

%description
Tomcat is the servlet container that is used in the official
Reference Implementation for the Java Servlet and JavaServer Pages
technologies.  The Java Servlet and JavaServer Pages specifications
are developed by Sun under the Java Community Process.

%prep
%setup -q -n jakarta-tomcat-%{version} -a 7
%patch2 -p0 -b .orig
chmod 755 bin/*.sh
rm -f bin/*.bat bin/tomcat.exe conf/*.orig
find -type f | xargs %{__python} %{SOURCE9}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%define tcdir $RPM_BUILD_ROOT%{_datadir}/tomcat
%{__mkdir_p} %{tcdir}
cp -r . %{tcdir}

# Replace the default server.xml with our cut-down default
mv %{tcdir}/conf/server.xml %{tcdir}/conf/default-server.xml
cp %{SOURCE5} %{tcdir}/conf/server.xml

# Install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/tomcat
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
install -m644 %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/tomcat
cp %{SOURCE6} %{tcdir}/bin

# Install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/tomcat

# Put the logs in /var/log/tomcat
%{__mkdir_p} $RPM_BUILD_ROOT/var/log
mv -f %{tcdir}/logs $RPM_BUILD_ROOT/var/log/tomcat
ln -s ../../../var/log/tomcat %{tcdir}/logs

# Put the config files in /etc/tomcat
%{__mkdir_p} $RPM_BUILD_ROOT/etc
mv -f %{tcdir}/conf $RPM_BUILD_ROOT/etc/tomcat
ln -s ../../../etc/tomcat %{tcdir}/conf

# Put the webapps in /var/lib/tomcat
%{__mkdir_p} $RPM_BUILD_ROOT/var/lib
mv -f %{tcdir}/webapps $RPM_BUILD_ROOT/var/lib/tomcat
ln -s ../../../var/lib/tomcat %{tcdir}/webapps

# Put the working directory in /var/cache/tomcat
%{__mkdir_p} $RPM_BUILD_ROOT/var/cache
mv -f %{tcdir}/work $RPM_BUILD_ROOT/var/cache/tomcat
ln -s ../../../var/cache/tomcat %{tcdir}/work

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -g 53 tomcat 2>/dev/null || :
/usr/sbin/useradd -u 53 -g tomcat -c "Tomcat server" \
    -s /bin/bash -r -d /var/lib/tomcat tomcat 2>/dev/null || :

%post
/sbin/chkconfig --add tomcat

%preun
if [ $1 = 0 ]; then
    /sbin/service tomcat stop > /dev/null 2>&1
    /sbin/chkconfig --del tomcat
fi

%files
%defattr(-,root,root)
%doc LICENSE README.txt RELEASE-* RUNNING.txt tomcat-4.0.1-servlets.patch
%config %{_sysconfdir}/logrotate.d/tomcat
%config %{_sysconfdir}/rc.d/init.d/tomcat
%config(noreplace) %{_sysconfdir}/sysconfig/tomcat
%{_datadir}/tomcat/logs
%attr(750,tomcat,tomcat) %dir %{_localstatedir}/log/tomcat
%config(noreplace) %{_sysconfdir}/tomcat/server.xml
%config(noreplace) %{_sysconfdir}/tomcat/catalina.policy
%config(noreplace) %{_sysconfdir}/tomcat/web.xml
%config(noreplace) %{_sysconfdir}/tomcat/tomcat-users.xml
%{_sysconfdir}/tomcat/server-noexamples.xml.config
%{_sysconfdir}/tomcat/default-server.xml
%dir %{_datadir}/tomcat
%{_datadir}/tomcat/conf
%{_datadir}/tomcat/work
%attr(750,tomcat,tomcat) %dir %{_localstatedir}/cache/tomcat
%{_datadir}/tomcat/bin
%dir %{_datadir}/tomcat/classes
%{_datadir}/tomcat/common
%{_datadir}/tomcat/lib
%{_datadir}/tomcat/server
%{_datadir}/tomcat/webapps
%config(noreplace) %{_localstatedir}/lib/tomcat/ROOT/index.html
%config(noreplace) %{_localstatedir}/lib/tomcat/ROOT/WEB-INF/web.xml
%{_localstatedir}/lib/tomcat/examples
%{_localstatedir}/lib/tomcat/webdav
%{_localstatedir}/lib/tomcat/manager
%{_localstatedir}/lib/tomcat/tomcat-docs
%{_localstatedir}/lib/tomcat/ROOT/*.gif

%changelog
* Tue Sep 24 2002 Gary Benson <gbenson@redhat.com> 4.0.5-1
- convert DOS text files to Unix ones (#71144)
- upgrade to 4.0.5 (fixes #71177, #73724 and CAN-2002-1148)
- fix examples in catalina.policy (#71175)

* Tue May 07 2002 Gary Benson <gbenson@redhat.com> 4.0.3-2
- remove workaround for now-fixed deficiency in mod_webapp.

* Mon Apr 08 2002 Gary Benson <gbenson@redhat.com> 4.0.3-1
- add dependency on IBMJava2-SDK

* Wed Apr 04 2002 Gary Benson <gbenson@redhat.com>
- upgrade to 4.0.3.

* Tue Feb 26 2002 Gary Benson <gbenson@redhat.com> 4.0.1-5
- fix the user/group adding in pre-install scriptlet.

* Mon Feb 18 2002 Gary Benson <gbenson@redhat.com>
- change uid and gid to 53 and move /var/tomcat to /var/lib/tomcat
- move /var/spool/tomcat to /var/cache/tomcat

* Thu Jan 31 2002 Gary Benson <gbenson@redhat.com> 4.0.1-4
- replace absolute links in the servlets with relative ones, so that
  the images and links work properly regardless of where the app is
  deployed.

* Wed Jan 30 2002 Gary Benson <gbenson@redhat.com> 4.0.1-3
- require a JDK rather than a JRE.

* Tue Jan 29 2002 Gary Benson <gbenson@redhat.com> 4.0.1-2
- tighten permissions on /var/{log,spool}/tomcat

* Mon Jan 14 2002 Gary Benson <gbenson@redhat.com>
- no, pick up directories in /usr/share/tomcat.
- move some more stuff into /var.
- add a user to run the service under.
- start and stop in %post and %preun.

* Fri Jan 11 2002 Gary Benson <gbenson@redhat.com> 4.0.1-1
- adapted for RHL

* Thu Jan 10 2002 Gary Benson <gbenson@redhat.com>
- prepare bin directory in %prep rather than in %install and %files
- pick up just files, not directories, in lib/tomcat

* Wed Nov 21 2001 Joe Orton <jorton@redhat.com>
- Initial revision.
